/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 2009 Toporov Konstantin. All rights reserved.
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 3 only ("GPL")  (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.gnu.org/copyleft/gpl.html  See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * You should include file containing license in each project.
 * If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * If you wish your version of this file to be governed by
 * the GPL Version 3, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [GPL Version 3] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under the GPL Version 3 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 3 code and therefore, elected the GPL
 * Version 3 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 * 
 * Contributor(s):
 * 
 * Portions Copyrighted 2009 Toporov Konstantin.
 */

package importer;

import com.healthmarketscience.jackcess.Database;
import com.healthmarketscience.jackcess.Table;
import java.awt.Container;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.Map;
import java.util.Vector;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.ParallelGroup;
import javax.swing.GroupLayout.SequentialGroup;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.filechooser.FileNameExtensionFilter;
import manager.ComplexManager;
import manager.GroupManager;
import manager.ProductManager;
import products.ComplexProduct;
import products.ProdGroup;
import products.ProductInBase;
import java.text.*;


public class MainFrame extends JFrame
  implements ActionListener
{
  private static final String START_IMPORT_FROM_DIACALC = "start import from diacalc";
  private static final String START_IMPORT_FROM_DIABET = "start import from diabet";
  private static final String SEARCH_DIACALC = "search diacalc base";
  private static final String SEARCH_DIACALCJ = "search diacalcj base";
  private static final String SEARCH_DIABET = "search diabet2000 base";
  private JLabel lblSourceDiaCalc;
  private JTextField fldSourceDiaCalc;
  private JLabel lblTarget;
  private JTextField fldTarget;
  private JButton btnDoImportFromDiaCalc;
  private JButton btnSearchDiaCalc;
  private JButton btnSearchDiaCalcJ;
  private JLabel lblSourceDiabet;
  private JTextField fldSourceDiabet;
  private JButton btnSearchDiabet;
  private JButton btnDoImportFromDiabet;
  private Database db;
  private static final String DiaCalcBaseName = "base.mdb";
  private static final String DiaCalcJBaseName = "base.sqlite";

  public MainFrame()
  {
    setTitle("Импорт из баз DiaCalc 2.04");
    this.lblSourceDiaCalc = new JLabel("Источник база DiaCalc 2.04");
    this.fldSourceDiaCalc = new JTextField(30);
    if (new File("base.mdb").exists())
      this.fldSourceDiaCalc.setText("base.mdb");
    else
      this.fldSourceDiaCalc.setText("");
    this.fldSourceDiaCalc.setEditable(false);
    this.btnSearchDiaCalc = new JButton("...");
    this.btnSearchDiaCalc.addActionListener(this);
    this.btnSearchDiaCalc.setActionCommand("search diacalc base");
    this.btnDoImportFromDiaCalc = new JButton("Начать импорт из базы DiaCalc");
    this.btnDoImportFromDiaCalc.addActionListener(this);
    this.btnDoImportFromDiaCalc.setActionCommand("start import from diacalc");
    this.lblTarget = new JLabel("Получатель база DiaCalcJ");
    this.fldTarget = new JTextField(30);
    if (new File("base.sqlite").exists())
      this.fldTarget.setText("base.sqlite");
    else
      this.fldTarget.setText("");
    this.fldTarget.setEditable(false);
    this.btnSearchDiaCalcJ = new JButton("...");
    this.btnSearchDiaCalcJ.addActionListener(this);
    this.btnSearchDiaCalcJ.setActionCommand("search diacalcj base");
    GroupLayout localGroupLayout = new GroupLayout(getContentPane());
    getContentPane().setLayout(localGroupLayout);
    localGroupLayout.setAutoCreateGaps(true);
    localGroupLayout.setAutoCreateContainerGaps(true);
    localGroupLayout.setHorizontalGroup(
            localGroupLayout.createParallelGroup()
            .addComponent(this.lblSourceDiaCalc)
            .addGroup(localGroupLayout.createSequentialGroup()
                .addComponent(this.fldSourceDiaCalc)
                .addComponent(this.btnSearchDiaCalc))
                
                .addComponent(this.lblTarget)
            .addGroup(localGroupLayout.createSequentialGroup()
                .addComponent(this.fldTarget)
                .addComponent(this.btnSearchDiaCalcJ))
            .addComponent(this.btnDoImportFromDiaCalc));
    localGroupLayout.setVerticalGroup(
            localGroupLayout.createSequentialGroup()
            .addComponent(this.lblSourceDiaCalc)
            .addGroup(localGroupLayout.createParallelGroup()
                .addComponent(this.fldSourceDiaCalc)
                .addComponent(this.btnSearchDiaCalc))
                
                .addComponent(this.lblTarget)
            .addGroup(localGroupLayout.createParallelGroup()
                .addComponent(this.fldTarget)
                .addComponent(this.btnSearchDiaCalcJ))
            .addComponent(this.btnDoImportFromDiaCalc));
    pack();
  }

  public void actionPerformed(ActionEvent paramActionEvent)
  {
    String str = paramActionEvent.getActionCommand();
    if ("start import from diacalc".equals(str))
    {
      doImport();
    }
    else if ("search diacalc base".equals(str))
    {
      searchDiacalc();
    }
    else
    {
      if (!("search diacalcj base".equals(str)))
        return;
      searchDiacalcj();
    }
  }

  private void searchDiacalc()
  {
    String str = searchFile("base.mdb", "mdb");
    if (str != null)
      this.fldSourceDiaCalc.setText(str);
    else
      this.fldSourceDiaCalc.setText("");
  }

  private void searchDiacalcj()
  {
    String str = searchFile("base.sqlite", "sqlite");
    System.out.println(str);
    if (str != null)
      this.fldTarget.setText(str);
    else
      this.fldSourceDiabet.setText("");
  }

  private String searchFile(String paramString1, String paramString2)
  {
    JFileChooser localJFileChooser = new JFileChooser(new File(System.getProperty("user.dir")));
    localJFileChooser.setAcceptAllFileFilterUsed(false);
    FileNameExtensionFilter localFileNameExtensionFilter = new FileNameExtensionFilter(paramString1, new String[] { paramString2 });
    localJFileChooser.setFileFilter(localFileNameExtensionFilter);
    int i = localJFileChooser.showOpenDialog(this);
    if (i == 0)
      return localJFileChooser.getSelectedFile().getAbsolutePath();
    return null;
  }

  private void doImport()
  {
    if ((this.fldSourceDiaCalc.getText().equals(this.fldTarget.getText())) ||
            (!(new File(this.fldSourceDiaCalc.getText()).exists())) ||
            (!(new File(this.fldTarget.getText()).exists())))
    {
      JOptionPane.showMessageDialog(this, "Имена файлов источника и цели должны различаться\nИли файлы должны существовать");
      return;
    }
    try
    {
      this.db = Database.open(new File(this.fldSourceDiaCalc.getText()));
    }
    catch (Exception localException1)
    {
      JOptionPane.showMessageDialog(this, "Неверно указано имя файла\n" + localException1.getLocalizedMessage());
      return;
    }
    Vector<ProdGroup> groups = new Vector<ProdGroup>();
    Vector<ProductInBase> products = new Vector<ProductInBase>();
    Vector<ProductInBase> prodsCmpl = new Vector<ProductInBase>();
    Vector<ComplexProduct> complex = new Vector<ComplexProduct>();
    Map mapMDB;
    System.out.println("Groups/////////////////////////");
    try
    {
      Table localTable1 = this.db.getTable("Groups");
      while ((mapMDB = localTable1.getNextRow()) != null)
      {
        //System.out.println(((String)mapMDB.get("Name")) + " " + ((Integer)mapMDB.get("Cod")) + " " + ((Number)mapMDB.get("Cod")).intValue());
        groups.add(
                new ProdGroup(
                    getInt(mapMDB,"Cod"),
                    getString(mapMDB,"Name"),
                    0));
      }
    }
    catch (Exception localException2)
    {
      JOptionPane.showMessageDialog(this, "Неудалось открыть таблицу Groups\n" + localException2.getLocalizedMessage());
      return;
    }
    System.out.println("Products/////////////////////////");
    try
    {
      Table localTable2 = this.db.getTable("Products");
      while ((mapMDB = localTable2.getNextRow()) != null)
      {
        //if (((Boolean)mapMDB.get("Aggregate")).booleanValue())
          //System.out.println(((String)mapMDB.get("Name")) + " " + ((Boolean)mapMDB.get("Aggregate")) + " " + ((Number)mapMDB.get("KeyField")).intValue() + " " + ((Number)mapMDB.get("GroupCod")).intValue());
          ProductInBase prod = new ProductInBase(
                getString(mapMDB,"Name"),
                getFloat(mapMDB,"WH"),
                getFloat(mapMDB,"FAT"),
                getFloat(mapMDB,"UG"),
                getInt(mapMDB,"GI"),
                getFloat(mapMDB,"Weigth"),
                getInt(mapMDB,"KeyField"),
                getBool(mapMDB,"Aggregate"),
                getInt(mapMDB,"GroupCod"),
                0);
          if (prod.isComplex()){
              prodsCmpl.add(prod);
          }else{
                products.add(prod);
          }
      }
    }
    catch (Exception localException3)
    {
      JOptionPane.showMessageDialog(this, "Неудалось открыть таблицу Products\n" + localException3.getLocalizedMessage());
      return;
    }
    System.out.println("Composition/////////////////////////");
    try
    {
      Table cmplTable = this.db.getTable("Composition");
      while ((mapMDB = cmplTable.getNextRow()) != null)
      {
        complex.add(new ComplexProduct(getString(mapMDB,"Name"),
                                       getFloat(mapMDB,"WH"),
                                       getFloat(mapMDB,"FAT"),
                                       getFloat(mapMDB,"UG"),
                                       getInt(mapMDB,"GI"),
                                       getFloat(mapMDB,"Weigth"),
                                       getInt(mapMDB,"KeyField"),
                                       getInt(mapMDB,"Owner") ));
      }
    }
    catch (Exception localException4)
    {
      JOptionPane.showMessageDialog(this, "Неудалось открыть таблицу Composition\n" + localException4.getLocalizedMessage());
      return;
    }
    System.out.println("gr="+groups.size()+" pr="+products.size()+
            " prCm="+prodsCmpl.size()+" cmpl="+complex.size());
    if (groups.size() > 0)
    {
        int totalGr = 0;
        int totalPr = 0;
        int totalCmpl = 0;
        GroupManager grManager = new GroupManager(this.fldTarget.getText());
      ProductManager prodManager = new ProductManager(this.fldTarget.getText());
      ComplexManager cmplManager = new ComplexManager(this.fldTarget.getText());
      while (groups.size()>0)
      {
        ProdGroup gr = groups.firstElement();
        Vector<ProdGroup> grEx = new Vector<ProdGroup>(grManager.getGroups(0));
        
        int i = 1;
        if (grEx.size() > 0)
          i = (grEx.get(grEx.size() - 1)).getSortInd() + 1;
        gr.setSortInd(i);
        grManager.addGroup(gr, 0); totalGr++;
        int grId = grManager.getLastInsertedId();
        groups.remove(0);
        
        Vector<ProductInBase> prods2add = new Vector<ProductInBase>();
        for (int k = products.size(); k>0 ; k--)//Обрабатываем простые продукты
        {
          ProductInBase prod = products.get(k-1);
          if (gr.getId() == prod.getOwner()){
                prod.setOwner(grId);
                prods2add.add(prod);
                products.remove(prod);
          }
        }
        if (prods2add.size()>0){
            totalPr += prods2add.size();
            prodManager.addCollectionProducts(prods2add, grId);
            //System.out.println("prods 2 add="+prods2add.size());
        }
        
        for(int cp=prodsCmpl.size();cp>0;cp--){//тут обрабатываем сложные продукты
              ProductInBase prodC = prodsCmpl.get(cp-1);
              if (gr.getId() == prodC.getOwner()){
                    prodC.setOwner(grId);
                    //Теперь его добавляем
                    prodManager.addProdInBase(prodC);
                    //System.out.println("add cmpl prod "+prodC.getName());
                    int prId = prodManager.getLastInsertedId();
                    prodsCmpl.remove(prodC);
                    totalPr++;
                    Vector<ComplexProduct> cmpl2add = new Vector<ComplexProduct>();
                    for(int c = complex.size();c>0;c--){
                        if (prodC.getId()!= complex.get(c-1).getOwner()) continue;
                        ComplexProduct cmpl = complex.get(c-1);
                        cmpl.setOwner(prId);
                        complex.remove(cmpl);
                        cmpl2add.add(cmpl);
                    }
                    if (cmpl2add.size()>0){
                        totalCmpl += cmpl2add.size();
                        //System.out.println("cmplprods 2 add="+cmpl2add.size());
                        cmplManager.addComplexProducts(cmpl2add, prId);
                    }
              }
        }
      }
      System.out.println("add gr"+totalGr+" pr="+totalPr+" cm="+totalCmpl);
      Toolkit.getDefaultToolkit().beep();
      JOptionPane.showMessageDialog(this, "Импорт завершен");
      this.btnDoImportFromDiaCalc.setEnabled(false);
    }
    else
    {
      JOptionPane.showMessageDialog(this, "Добавять нечего");
      return;
    }
  }

  private Float getFloat(Map mapMDB,String field){
     Object o = mapMDB.get(field);
     if (o!=null){
         return ((Double)o).floatValue();
     }
     else return 0.0f;
  }
  private String getString(Map mapMDB,String field){
     Object o = mapMDB.get(field);
     if (o!=null){
         return o.toString();
     }
     else return "";
  }
  private Integer getInt(Map mapMDB,String field){
     Object o = mapMDB.get(field);
     if (o!=null){
         return (Integer)o;
     }
     else return 0;
  }
    private Boolean getBool(Map mapMDB,String field){
     Object o = mapMDB.get(field);
     if (o!=null){
         return (Boolean)o;
     }
     else return false;
   }
}