package manager;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collection;
import products.ComplexProduct;
import products.ProductW;

public class ComplexManager
{
  private ManagementSystem manager;

  public ComplexManager(String paramString)
  {
    this.manager = ManagementSystem.getInstance(paramString);
  }

  public Collection getComposition(int paramInt)
  {
    ArrayList localArrayList = new ArrayList();
    try
    {
      PreparedStatement localPreparedStatement = this.manager.getConnection().prepareStatement("SELECT Name, Prot, Fat, Carb, Gi, Weight, idProd, Owner FROM complex WHERE Owner=? ORDER BY Name");
      localPreparedStatement.setInt(1, paramInt);
      ResultSet localResultSet = localPreparedStatement.executeQuery();
      while (localResultSet.next())
        localArrayList.add(new ComplexProduct(localResultSet.getString("Name"), localResultSet.getFloat("Prot"), localResultSet.getFloat("Fat"), localResultSet.getFloat("Carb"), localResultSet.getInt("Gi"), localResultSet.getFloat("Weight"), localResultSet.getInt("idProd"), localResultSet.getInt("Owner")));
      localResultSet.close();
      localPreparedStatement.close();
      this.manager.getConnection().commit();
    }
    catch (SQLException localSQLException)
    {
      localSQLException.printStackTrace();
    }
    return localArrayList;
  }

  public Collection addComplexProducts(Collection paramCollection, int paramInt)
  {
    try
    {
      PreparedStatement localPreparedStatement = this.manager.getConnection().prepareStatement("INSERT INTO complex (Name, Prot, Fat, Carb, Gi, Weight, Owner) VALUES (?, ?, ?, ?, ?, ?, ?)");
      Object[] arrayOfObject = paramCollection.toArray();
      for (int i = 0; i < paramCollection.size(); ++i)
      {
        ProductW localProductW = (ProductW)arrayOfObject[i];
        localPreparedStatement.setString(1, localProductW.getName());
        localPreparedStatement.setFloat(2, localProductW.getProt());
        localPreparedStatement.setFloat(3, localProductW.getFat());
        localPreparedStatement.setFloat(4, localProductW.getCarb());
        localPreparedStatement.setInt(5, localProductW.getGi());
        localPreparedStatement.setFloat(6, localProductW.getWeight());
        localPreparedStatement.setInt(7, paramInt);
        localPreparedStatement.executeUpdate();
      }
      localPreparedStatement.close();
      this.manager.getConnection().commit();
    }
    catch (SQLException localSQLException)
    {
      localSQLException.printStackTrace();
    }
    return getComposition(paramInt);
  }

  public Collection addProduct(ProductW paramProductW, int paramInt)
  {
    try
    {
      PreparedStatement localPreparedStatement = this.manager.getConnection().prepareStatement("INSERT INTO complex (Name, Prot, Fat, Carb, Gi, Weight, Owner) VALUES (?, ?, ?, ?, ?, ?, ?)");
      localPreparedStatement.setString(1, paramProductW.getName());
      localPreparedStatement.setFloat(2, paramProductW.getProt());
      localPreparedStatement.setFloat(3, paramProductW.getFat());
      localPreparedStatement.setFloat(4, paramProductW.getCarb());
      localPreparedStatement.setInt(5, paramProductW.getGi());
      localPreparedStatement.setFloat(6, paramProductW.getWeight());
      localPreparedStatement.setInt(7, paramInt);
      localPreparedStatement.executeUpdate();
      localPreparedStatement.close();
      this.manager.getConnection().commit();
    }
    catch (SQLException localSQLException)
    {
      localSQLException.printStackTrace();
    }
    return getComposition(paramInt);
  }

  public Collection updateProduct(ComplexProduct paramComplexProduct)
  {
    try
    {
      PreparedStatement localPreparedStatement = this.manager.getConnection().prepareStatement("UPDATE complex SET Weight=? WHERE idProd=?");
      localPreparedStatement.setFloat(1, paramComplexProduct.getWeight());
      localPreparedStatement.setInt(2, paramComplexProduct.getId());
      localPreparedStatement.executeUpdate();
      localPreparedStatement.close();
      this.manager.getConnection().commit();
    }
    catch (SQLException localSQLException)
    {
      localSQLException.printStackTrace();
    }
    return getComposition(paramComplexProduct.getOwner());
  }

  public Collection deleteProduct(ComplexProduct paramComplexProduct)
  {
    try
    {
      PreparedStatement localPreparedStatement = this.manager.getConnection().prepareStatement("DELETE FROM complex WHERE idProd=?");
      localPreparedStatement.setInt(1, paramComplexProduct.getId());
      localPreparedStatement.executeUpdate();
      localPreparedStatement.close();
      this.manager.getConnection().commit();
    }
    catch (SQLException localSQLException)
    {
      localSQLException.printStackTrace();
    }
    return getComposition(paramComplexProduct.getOwner());
  }

  public Collection flushProducts(int paramInt)
  {
    try
    {
      PreparedStatement localPreparedStatement = this.manager.getConnection().prepareStatement("DELETE FROM complex WHERE Owner=?");
      localPreparedStatement.setInt(1, paramInt);
      localPreparedStatement.executeUpdate();
      localPreparedStatement.close();
      this.manager.getConnection().commit();
    }
    catch (SQLException localSQLException)
    {
      localSQLException.printStackTrace();
    }
    return getComposition(paramInt);
  }
}

/* Location:           /home/connie/Documents/to_send/Importer/Importer.jar
 * Qualified Name:     manager.ComplexManager
 * JD-Core Version:    0.5.3
 */