package manager;

import java.io.PrintStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import products.ProdGroup;
import products.ProductInBase;

public class GroupManager
{
  private ManagementSystem manager;
  public static final int ONLY_EXISTS_GROUPS = 0;
  public static final int VIRTUAL_GROUP_ALSO = 1;
  private int lastInsertedId = -1;

  public GroupManager(String paramString)
  {
    this.manager = ManagementSystem.getInstance(paramString);
  }

  public Collection getGroups(int paramInt)
  {
    ArrayList localArrayList = new ArrayList();
    try
    {
      Statement localStatement = this.manager.getConnection().createStatement();
      ResultSet localResultSet = localStatement.executeQuery("SELECT idGroup, Name, sortInd FROM groups ORDER BY sortInd");
      int i = 1;
      while (localResultSet.next())
      {
        if ((i != 0) && (paramInt == 1))
        {
          i = 0;
          localArrayList.add(new ProdGroup(0, "Часто используемые", 0));
        }
        localArrayList.add(new ProdGroup(localResultSet.getInt("idGroup"), localResultSet.getString("Name"), localResultSet.getInt("sortInd")));
      }
      localResultSet.close();
      localStatement.close();
      this.manager.getConnection().commit();
    }
    catch (SQLException localSQLException)
    {
      localSQLException.printStackTrace();
    }
    return localArrayList;
  }

  public Collection addGroup(ProdGroup paramProdGroup, int paramInt)
  {
    try
    {
      PreparedStatement localPreparedStatement = this.manager.getConnection().prepareStatement("INSERT INTO groups (Name, sortInd) VALUES (?, ?)");
      localPreparedStatement.setString(1, paramProdGroup.getName());
      localPreparedStatement.setInt(2, paramProdGroup.getSortInd());
      localPreparedStatement.executeUpdate();
      localPreparedStatement.close();
    }
    catch (SQLException localSQLException1)
    {
      localSQLException1.printStackTrace();
    }
    try
    {
      Statement localStatement = this.manager.getConnection().createStatement();
      ResultSet localResultSet = localStatement.executeQuery("SELECT last_insert_rowid() FROM groups");
      this.lastInsertedId = -1;
      if (localResultSet.next())
        this.lastInsertedId = localResultSet.getInt(1);
      //System.out.println("group id last=" + this.lastInsertedId);
      localStatement.close();
      this.manager.getConnection().commit();
    }
    catch (SQLException localSQLException2)
    {
      localSQLException2.printStackTrace();
    }
    return getGroups(paramInt);
  }

  public Collection deleteGroup(ProdGroup paramProdGroup, int paramInt)
  {
    ArrayList localArrayList = new ArrayList();
    Object localObject1;
    try
    {
      PreparedStatement localPreparedStatement1 = this.manager.getConnection().prepareStatement("SELECT idProd FROM products WHERE idGroup=? AND compl=1");
      localPreparedStatement1.setInt(1, paramProdGroup.getId());
      localObject1 = localPreparedStatement1.executeQuery();
      while (((ResultSet)localObject1).next())
        localArrayList.add(new ProductInBase("", 0.0F, 0.0F, 0.0F, 0, 100.0F, ((ResultSet)localObject1).getInt("idProd"), true, 0, 0));
      localPreparedStatement1.close();
    }
    catch (SQLException localSQLException1)
    {
      localSQLException1.printStackTrace();
    }
    if (localArrayList.size() > 0)
      try
      {
        PreparedStatement localPreparedStatement2 = this.manager.getConnection().prepareStatement("DELETE FROM complex WHERE Owner=?");
        localObject1 = localArrayList.iterator();
        while (((Iterator)localObject1).hasNext())
        {
          Object localObject2 = ((Iterator)localObject1).next();
          localPreparedStatement2.setInt(1, ((ProductInBase)localObject2).getId());
          localPreparedStatement2.executeUpdate();
        }
        localPreparedStatement2.close();
      }
      catch (SQLException localSQLException2)
      {
        localSQLException2.printStackTrace();
      }
    try
    {
      PreparedStatement localPreparedStatement3 = this.manager.getConnection().prepareStatement("DELETE FROM products WHERE idGroup=?");
      localPreparedStatement3.setInt(1, paramProdGroup.getId());
      localPreparedStatement3.executeUpdate();
      localPreparedStatement3.close();
    }
    catch (SQLException localSQLException3)
    {
      localSQLException3.printStackTrace();
    }
    try
    {
      PreparedStatement localPreparedStatement4 = this.manager.getConnection().prepareStatement("DELETE FROM groups WHERE idGroup=?");
      localPreparedStatement4.setInt(1, paramProdGroup.getId());
      localPreparedStatement4.executeUpdate();
      localPreparedStatement4.close();
    }
    catch (SQLException localSQLException4)
    {
      localSQLException4.printStackTrace();
    }
    try
    {
      this.manager.getConnection().commit();
    }
    catch (SQLException localSQLException5)
    {
      localSQLException5.printStackTrace();
    }
    return ((Collection)getGroups(paramInt));
  }

  public Collection updateGroup(ProdGroup paramProdGroup, int paramInt)
  {
    try
    {
      PreparedStatement localPreparedStatement = this.manager.getConnection().prepareStatement("UPDATE groups SET Name=?, sortInd=? WHERE idGroup=?");
      localPreparedStatement.setString(1, paramProdGroup.getName());
      localPreparedStatement.setInt(2, paramProdGroup.getSortInd());
      localPreparedStatement.setInt(3, paramProdGroup.getId());
      localPreparedStatement.execute();
      localPreparedStatement.close();
      this.manager.getConnection().commit();
    }
    catch (SQLException localSQLException)
    {
      localSQLException.printStackTrace();
    }
    return getGroups(paramInt);
  }

  public int getLastInsertedId()
  {
    return this.lastInsertedId;
  }
}

/* Location:           /home/connie/Documents/to_send/Importer/Importer.jar
 * Qualified Name:     manager.GroupManager
 * JD-Core Version:    0.5.3
 */