package products;

public class ProductW
{
  protected String Name = new String();
  protected float Prot = 0.0F;
  protected float Fat = 0.0F;
  protected float Carb = 0.0F;
  protected int Gi = 0;
  protected float Weight = 0.0F;

  public ProductW()
  {
  }

  public ProductW(String paramString, float paramFloat1, float paramFloat2, float paramFloat3, int paramInt, float paramFloat4)
  {
    this.Name = paramString;
    this.Prot = paramFloat1;
    this.Fat = paramFloat2;
    this.Carb = paramFloat3;
    setGi(paramInt);
    setWeight(paramFloat4);
  }

  public ProductW(ProductW paramProductW)
  {
    this.Name = paramProductW.getName();
    this.Prot = paramProductW.getProt();
    this.Fat = paramProductW.getFat();
    this.Carb = paramProductW.getCarb();
    this.Gi = paramProductW.getGi();
    this.Weight = paramProductW.getWeight();
  }

  public String getName()
  {
    return this.Name;
  }

  public float getProt()
  {
    return this.Prot;
  }

  public float getFat()
  {
    return this.Fat;
  }

  public float getCarb()
  {
    return this.Carb;
  }

  public int getGi()
  {
    return this.Gi;
  }

  public float getWeight()
  {
    return this.Weight;
  }

  public float getCalories()
  {
    return (4.1F * getAllProt() + 9.3F * getAllFat() + 4.1F * getAllCarb());
  }

  public void flush()
  {
    this.Name = "";
    this.Prot = 0.0F;
    this.Fat = 0.0F;
    this.Carb = 0.0F;
    this.Gi = 0;
    this.Weight = 0.0F;
  }

  public void setName(String paramString)
  {
    this.Name = paramString;
  }

  public void setProt(float paramFloat)
  {
    this.Prot = paramFloat;
  }

  public void setFat(float paramFloat)
  {
    this.Fat = paramFloat;
  }

  public void setCarb(float paramFloat)
  {
    this.Carb = paramFloat;
  }

  public void setGi(int paramInt)
  {
    if (paramInt < 0)
      this.Gi = 0;
    else if (paramInt > 100)
      this.Gi = 100;
    else
      this.Gi = paramInt;
  }

  public void setWeight(float paramFloat)
  {
    if (paramFloat < 0.0F)
      this.Weight = 0.0F;
    else
      this.Weight = paramFloat;
  }

  public float getAllProt()
  {
    return (this.Prot * this.Weight / 100.0F);
  }

  public float getAllFat()
  {
    return (this.Fat * this.Weight / 100.0F);
  }

  public float getAllCarb()
  {
    return (this.Carb * this.Weight / 100.0F);
  }

  public void changeWeight(float paramFloat)
  {
    if ((paramFloat > 0.0F) && (this.Weight != 0.0F))
    {
      float f = this.Weight / paramFloat;
      if ( (this.Prot *= f) > 100.0F)
        this.Prot = 100.0F;
      if ( (this.Fat *= f) > 100.0F)
        this.Fat = 100.0F;
      if ( (this.Carb *= f) > 100.0F)
        this.Carb = 100.0F;
    }
    else
    {
      this.Prot = 0.0F;
      this.Fat = 0.0F;
      this.Carb = 0.0F;
      this.Gi = 0;
    }
    setWeight(paramFloat);
  }

  public void plusProd(ProductW paramProductW)
  {
    float f1 = this.Prot * this.Weight / 100.0F + paramProductW.getAllProt();
    float f2 = this.Fat * this.Weight / 100.0F + paramProductW.getAllFat();
    float f3 = this.Carb * this.Weight / 100.0F + paramProductW.getAllCarb();
    float f4 = this.Gi / 100.0F * this.Carb * this.Weight / 100.0F + paramProductW.getGi() / 100.0F * paramProductW.getAllCarb();
    int i;
    if (f3 == 0.0F)
      i = 50;
    else
      i = Math.round(100.0F * f4 / f3);
    float f5 = this.Weight + paramProductW.getWeight();
    if (f5 != 0.0F)
    {
      if (this.Name.length() == 0)
      {
        this.Name = paramProductW.getName();
      }
      else
      {
        ProductW tmp166_165 = this;
        tmp166_165.Name = tmp166_165.Name + " " + paramProductW.getName();
      }
      this.Prot = (100.0F * f1 / f5);
      this.Fat = (100.0F * f2 / f5);
      this.Carb = (100.0F * f3 / f5);
      setGi(i);
      this.Weight = f5;
    }
    else
    {
      flush();
    }
  }

  public boolean equals(ProductW paramProductW)
  {
    return ((this.Name.equals(paramProductW.Name)) && (this.Prot == paramProductW.Prot) && (this.Fat == paramProductW.Fat) && (this.Carb == paramProductW.Carb) && (this.Gi == paramProductW.Gi) && (this.Weight == paramProductW.Weight));
  }

  public String toString()
  {
    return this.Name + " " + this.Prot + " " + this.Fat + " " + this.Carb + " " + this.Gi;
  }
}

/* Location:           /home/connie/Documents/to_send/Importer/Importer.jar
 * Qualified Name:     products.ProductW
 * JD-Core Version:    0.5.3
 */